#include "lcd.h"

void lcd_init( unsigned char dispAttr )
{
	LCD_DDR_RS = 1;
	LCD_DDR_DI = 1;
	LCD_DDR_SCK = 1;
	LCD_DDR_CS = 1;
	LCD_CS = 1;
	_delay_ms( 15 );				// wait 15ms
#if LCD_VOLTAGE
	lcd_command( 0x39 );			// Function Set; 8 Bit; 2 Zeilen, Istr.Tab 1
	lcd_command( 0x1C );			// Bias Set 
	lcd_command( 0x52 );			// Power Controll
	lcd_command( 0x69 );			// Flower control ?
	lcd_command( LCD_CONTRAST );			// Contrast set
#else
	lcd_command( 0x39 );			// Function set
	lcd_command( 0x14 );			// Bias Set 
	lcd_command( 0x55 );			// Power Controll
	lcd_command( 0x6d );			// Flower control ?
	lcd_command( LCD_CONTRAST );			// Contrast set
#endif
	lcd_command( 0x0F );			// 
	lcd_command( 0x01 );			// Disoplay lschen 
	lcd_command( 0x06 );			// Entry Mode set - Display wartet auf Eingabe
	lcd_command( dispAttr );		// Display ON/OFF, Courser ON/OFF, Blink ON/OFF
}


static void lcd_byte( unsigned char data )
{
	unsigned char i;

	LCD_CS = 0;
	for( i = 8; i; i-- )
	{
		LCD_SCK = 0;
		LCD_DI = 0;
		if( data & 0x80 )
			LCD_DI = 1;
		data <<= 1;
		LCD_SCK = 1;
	}
	LCD_CS = 1;
	_delay_us( 45 );			// 45us
}


void lcd_clrscr(void)
{
	lcd_command(1<<LCD_CLR);
}


void lcd_gotoxy(unsigned char x, unsigned char y)
{
	switch( x )
	{
		case 1: y += 0x40;
	}
	lcd_command( 0x80 + y );
}


void lcd_putc(char c)
{
	lcd_byte(c);
}


void lcd_puts(const char *s)
{
	while( *s )
	{
		lcd_data( *s );
		s++;
	}
}


void lcd_command(unsigned char cmd)
{
	LCD_RS = 0;
	lcd_byte( cmd );
	switch( cmd )
	{
		case 1:
		case 2:
		case 3: _delay_ms( 2 );		// wait 2ms
	}
}


void lcd_data(unsigned char data)
{
	LCD_RS = 1;
	lcd_byte( data );
}